
import AbreCam
import Actions
import AniSound
import Auras
import AuxFuncs
import B3DLib
import BInput
import Bladex
import Breakings
import Button
import CharStats
import Damage
import dust
import darfuncs
import DMusic
import Doors
import EnemyTypes
# import ExtraData
import GameText
import GenFX
import GotoMapVars
import ItemTypes
import LavaDefDamage
import LevelFuncs
import Levers
import Locks
import math
import MusicTool
import NetSounds
import Objects
import ObjStore
import OnOff
import Ontake
import pocimac
import Raster
import ReadGSFile
import Reference
import Scorer
import Sounds
import Sparks
import Stars
import storm
import string
import Torchs
import Water
import whrandom
from CharData import CharMaxLifeValue

import travpos
import asCONFIG


GameText.MapList ['ANGELSTEELNIGHT'] = 'AngelSteelNight'



###############################################################################
# globals and definitions
###############################################################################



###############################################################################
# def for playerlife
###############################################################################

def change_playerlife():

	for i in range(20):
	
		CharMaxLifeValue['Barbarian_N'][i-1] = 1
		CharMaxLifeValue['Amazon_N'][i-1]    = 1
		CharMaxLifeValue['Dwarf_N'][i-1]     = 1
		CharMaxLifeValue['Knight_N'][i-1]    = 1

	Bladex.GetEntity("Player1").Life = 1




###############################################################################
# respawn and clean
###############################################################################


def DeathOfEnemy1(entity):

	global deaths
	global ratio

	me=Bladex.GetEntity(entity)
        if me.Data.OldImDeadFunc:
                me.Data.OldImDeadFunc(entity)
        
	global killcount1
	global killcount2
	global killcount3
	global killcount4
	allkills = killcount1 + killcount2 + killcount3 + killcount4 +1
	ratio = allkills/(deaths+1)
	GameText.ShowMessage("kills:   "+str(allkills)+"\n deaths:   "+str(deaths)+"\n average kills per life:   "+str(ratio))
	Bladex.AddScheduledFunc(Bladex.GetTime()+4.0, GameText.ShowMessage,())
	
	killcount1 = killcount1 + 1

	global RespawnTime
	Bladex.AddScheduledFunc(Bladex.GetTime() + asCONFIG.RespawnTime, Respawn1,())
	Bladex.AddScheduledFunc(Bladex.GetTime() + 10.0, HideBody,(me.Name,))


def DeathOfEnemy2(entity):

	me=Bladex.GetEntity(entity)
        if me.Data.OldImDeadFunc:
                me.Data.OldImDeadFunc(entity)
        
	global killcount1
	global killcount2
	global killcount3
	global killcount4
	allkills = killcount1 + killcount2 + killcount3 + killcount4 +1
	ratio = allkills/(deaths+1)
	GameText.ShowMessage("kills:   "+str(allkills)+"\n deaths:   "+str(deaths)+"\n average kills per life:   "+str(ratio))
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.0, GameText.ShowMessage,())
	
	killcount2 = killcount2 + 1

	global RespawnTime
	Bladex.AddScheduledFunc(Bladex.GetTime() + asCONFIG.RespawnTime, Respawn2,())
	Bladex.AddScheduledFunc(Bladex.GetTime() + 10.0, HideBody,(me.Name,))


def DeathOfEnemy3(entity):

	me=Bladex.GetEntity(entity)
        if me.Data.OldImDeadFunc:
                me.Data.OldImDeadFunc(entity)
        
	global killcount1
	global killcount2
	global killcount3
	global killcount4
	allkills = killcount1 + killcount2 + killcount3 + killcount4 +1
	ratio = allkills/(deaths+1)
	GameText.ShowMessage("kills:   "+str(allkills)+"\n deaths:   "+str(deaths)+"\n average kills per life:   "+str(ratio))
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.0, GameText.ShowMessage,())
	
	killcount3 = killcount3 + 1

	global RespawnTime
	Bladex.AddScheduledFunc(Bladex.GetTime() + asCONFIG.RespawnTime, Respawn3,())
	Bladex.AddScheduledFunc(Bladex.GetTime() + 10.0, HideBody,(me.Name,))



def DeathOfEnemy4(entity):

	me=Bladex.GetEntity(entity)
        if me.Data.OldImDeadFunc:
                me.Data.OldImDeadFunc(entity)
        
	global killcount1
	global killcount2
	global killcount3
	global killcount4
	allkills = killcount1 + killcount2 + killcount3 + killcount4 +1
	ratio = allkills/(deaths+1)
	GameText.ShowMessage("kills:   "+str(allkills)+"\n deaths:   "+str(deaths)+"\n average kills per life:   "+str(ratio))
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.0, GameText.ShowMessage,())

	killcount4 = killcount4 + 1

	global RespawnTime
	Bladex.AddScheduledFunc(Bladex.GetTime() + asCONFIG.RespawnTime, Respawn4,())
	Bladex.AddScheduledFunc(Bladex.GetTime() + 10.0, HideBody,(me.Name,))




def HideBody(body):

	global RemoveBodies
	if (asCONFIG.RemoveBodies == "1"):

		o=Bladex.GetEntity(body)
		o.Alpha=1
		o.RasterMode="Read"
		o.CastShadows=0     	
		### dust.EnPolvoPerson(o.Name, 100, 0)
		AuxFuncs.FadeObject(o.Name, 1, 0, 5.0)
		Bladex.AddScheduledFunc(Bladex.GetTime() +5.1, o.RemoveFromWorld,())



remain = ["CustomTorch","CustomBow","CustomWeapon","CustomHolySword",
	"charweapon1","charweapon2","charweapon3","charweapon4",
	"chararmor","charshield"]

for i in range(50):
	remain.append("markline_"+str(i))
	remain.append("markline2_"+str(i))



def RemoveObject(obj):
	
	if not (obj.Name in remain):

		Reference.debugprint("CLEANING: " + obj.Name)
		obj.RemoveFromWorld()
		obj.SubscribeToList("Pin")



def RemoveBreakableObject(obj):

	try:
		brkobj = obj.Data.brkobjdata
		for i in brkobj.n_piezas:
			RemoveObject(brkobj.pieza[i])
	except:
		pass

	if not (obj.Name in remain):
					
		RemoveObject(obj)


def InInventory(objtype, name, inv):

	if objtype == Reference.OBJ_WEAPON:
		for i in range(inv.nWeapons):
			if inv.GetWeapon(i) == name:
				return 1
	elif objtype == Reference.OBJ_SHIELD:
		for i in range(inv.nShields):
			if inv.GetShield(i) == name:
				return 1
	return 0



def CleanUpArena():

	global CleanBlood

	global cleanCount
	cleanCount = 0
	# call the garbage collector
	ObjStore.CheckStore()
	# clean up everything
	player = Bladex.GetEntity("Player1")
	nents = Bladex.nEntities()
	inv = player.GetInventory()
	for i in range(nents):
		obj = Bladex.GetEntity(i)
		if obj == None:
			continue
		if obj.Person == 1: 
			# bodies are automatically cleaned by the enemy generator
			Reference.debugprint("NOT CLEANED: " + obj.Name)
		else:
			objtype = Reference.GiveObjectFlag(obj.Name)
			if objtype == Reference.OBJ_WEAPON or objtype == Reference.OBJ_SHIELD:
				# If parent is set, just leave the object
				if obj.Parent == None:
					# Check to see if the player has it
					if InInventory(objtype, obj.Name, inv) == 0: 
						owner = Bladex.GetEntity(obj.Name[:len(obj.Name)-7])
						if owner == None:
							RemoveBreakableObject(obj)
							continue
				Reference.debugprint("NOT CLEANED: " + obj.Name + " " + obj.Kind + " " + str(objtype))
			elif obj.Kind[:4] == "Limb":
				RemoveObject(obj)
			elif objtype == Reference.OBJ_STANDARD:	
				if obj.Parent == None:
					RemoveObject(obj)
			elif obj.Kind == "Entity Pool":
				if (asCONFIG.CleanBlood == "1"):
					RemoveObject(obj)
			else:
				# look for weapon/shield pieces without owners.
				idx = string.find(obj.Name, "Pieza")
				if idx != -1:
					parent = Bladex.GetEntity(obj.Name[:idx])
					if parent == None:
						RemoveObject(obj)
						continue
				Reference.debugprint("NOT CLEANED: " + obj.Name + " " + obj.Kind + " " + str(objtype))




################################################################################
# sun settings 
################################################################################

def day():

	Raster.SetDomeColor(255,255,255)
	Bladex.SetSun(1,1.8,0.4,-1)

	o=Bladex.GetEntity("NightSunCore")
	o.Position = 0,-30000,0

	o=Bladex.GetEntity("NightSunCorona")
	o.Position = 0,-30000,0



def dawn():

	Raster.SetDomeColor(255,160,160)
	Bladex.SetSun(1,1.8,0.0,-1)
	
	o=Bladex.GetEntity("NightSunCore")
	o.Position = 0,-30000,0

	o=Bladex.GetEntity("NightSunCorona")
	o.Position = 0,-30000,0



def night():
	
	Bladex.SetSun(0,1.8,0.0,-1)
	Raster.SetDomeColor(30,30,30)

	o=Bladex.GetEntity("NightSunCore")
	o.Position = -70000,-15000,40000

	o=Bladex.GetEntity("NightSunCorona")
	o.Position = -70000,-15000,40000




################################################################################
# dust defs 
################################################################################


def MY_DropDust(x,y,z,vx,vy,vz,Ptypo="Tierrax",t2l=64, Death=100000):

	tierra1=Bladex.CreateEntity("Cristales", "Entity Particle System D1", x, y, z)
	tierra1.ParticleType=Ptypo
	tierra1.PPS=100 # intensitt
	tierra1.YGravity=5000 #9800
	tierra1.Friction=0.1 #0.1
	tierra1.Velocity=vx,vy,vz
	tierra1.RandomVelocity=50.0
	tierra1.Time2Live=t2l
	tierra1.DeathTime=Bladex.GetTime()+Death	
	return tierra1


def MY_Tierrilla(x,y,z, dx,dz):

	tierra2=Bladex.CreateEntity("Tierrilla", "Entity Particle System D3", x, y, z)
	tierra2.D1= 0, 0, 0    # 3000, 0, 0
	tierra2.D2= 0, 0, 0    # 3000, 0, 3000
	tierra2.Time2Live=68 #68
	tierra2.YGravity= -100
	tierra2.Velocity=dx,-1000,dz
	tierra2.RandomVelocity=5
	tierra2.ParticleType="Polvin"
	tierra2.PPS = 100 #intensidad
	tierra2.DeathTime=Bladex.GetTime()+100000


#MY_DropDust(8614.29193926,-6125.17266708,-8545.04022433, 1,1,1) #statue
#MY_DropDust(-8510.4007079,-6129.52072468,8591.73180729, 1,1,1) #statue

MY_DropDust(13000,1600,13000, 1,1,1)
MY_DropDust(13000,1600,-13000, 1,1,1)
MY_DropDust(-13000,1600,13000, 1,1,1)
MY_DropDust(-13000,1600,-13000, 1,1,1)


# MY_Tierrilla(0,599970,0,  0,0) #mitte unten




################################################################################
# change all stars' positions 
################################################################################ 


def change_stars():

	global StarsNumber

	xCoord     = [0]
	yCoord     = [0]
	zCoord     = [0]

	for i in range(56): 

		xCoord.append(i * 1000)
		xCoord.append(i * -1000)
		yCoord.append(i * 1000)
		yCoord.append(i * -1000)


	for i in range(19):

		zCoord.append(i * 1000)
		zCoord.append(i * -1000)

	for i in range(asCONFIG.StarsNumber):
	

		idx = whrandom.randint(0, len(xCoord)-1)
		xCOORD = xCoord[idx]
	
		idx = whrandom.randint(0, len(yCoord)-1)
		yCOORD = yCoord[idx]

		idx = whrandom.randint(0, len(zCoord)-1)
		zCOORD = zCoord[idx]


		o=Bladex.GetEntity("star_" +str(i))
		o.Position = (xCOORD, zCOORD, yCOORD)



def flicker_stars():

	global StarsNumber

	xCoord     = [0]
	yCoord     = [0]
	zCoord     = [0]

	for i in range(56): 

		xCoord.append(i * 1000)
		xCoord.append(i * -1000)
		yCoord.append(i * 1000)
		yCoord.append(i * -1000)


	for i in range(19):

		zCoord.append(i * 1000)
		zCoord.append(i * -1000)

	for i in range(asCONFIG.StarsNumber):
	

		idx = whrandom.randint(0, len(xCoord)-1)
		xCOORD = xCoord[idx]
	
		idx = whrandom.randint(0, len(yCoord)-1)
		yCOORD = yCoord[idx]

		idx = whrandom.randint(0, len(zCoord)-1)
		zCOORD = zCoord[idx]


		o=Bladex.GetEntity("star_" +str(i))
		o.Position = (xCOORD, zCOORD, yCOORD)


	Bladex.AddScheduledFunc(Bladex.GetTime()+0.075, flicker_stars,())




def flicker_colored_stars():


	global StarsNumber

	xCoord     = [0]
	yCoord     = [0]
	zCoord     = [0]

	for i in range(56): 

		xCoord.append(i * 1000)
		xCoord.append(i * -1000)
		yCoord.append(i * 1000)
		yCoord.append(i * -1000)


	for i in range(19):

		zCoord.append(i * 1000)
		zCoord.append(i * -1000)

	for i in range(asCONFIG.StarsNumber):
	

		idx = whrandom.randint(0, len(xCoord)-1)
		xCOORD = xCoord[idx]
	
		idx = whrandom.randint(0, len(yCoord)-1)
		yCOORD = yCoord[idx]

		idx = whrandom.randint(0, len(zCoord)-1)
		zCOORD = zCoord[idx]


		o=Bladex.GetEntity("star_" +str(i))
		o.Color = whrandom.randint(0, 255),whrandom.randint(0, 255),whrandom.randint(0, 255)
		o.Position = (xCOORD, zCOORD, yCOORD)


	Bladex.AddScheduledFunc(Bladex.GetTime()+0.75, flicker_stars,())





################################################################################
# ONENTER EVENTS
################################################################################





################################################################################
# ONTAKE EVENTS 
################################################################################





