


global DomeKind

if (asCONFIG.DomeKind == "0"):
	Raster.SetDomeColor(255,255,255)

if (asCONFIG.DomeKind == "1"):
	Raster.SetDomeColor(10,10,10)


###############################################################################
# intro music when available
###############################################################################



try:
	VOLUMEN = 2
	def playintromusic():
		Bladex.ExeMusicEvent( Bladex.GetMusicEvent ("IntroMusic"))
	Bladex.AddMusicEventMP3("IntroMusic","..\\..\\Maps\\AngelSteel\\ThePowerOfThySword.mp3",1,1,VOLUMEN,100,0,0)
	Bladex.AddScheduledFunc(Bladex.GetTime() + 1.00, playintromusic,())

except :
	pass





###############################################################################
# char equip
###############################################################################


if (Bladex.GetEntity('Player1').Kind[0] == 'B'):
	
	char=Bladex.GetEntity("Player1")
	inv=char.GetInventory()

	o=Bladex.CreateEntity("charweapon1","BigSword",0.0,-1178.14055211,40000, "Weapon")
	ItemTypes.ItemDefaultFuncs (o)
	o.Scale=1.0
	o.Orientation=(0.707106769085,-0.707106769085,0.0,0.0)

	o=Bladex.CreateEntity("charweapon2","SawSword",-40000,-1089.88066932,0.0, "Weapon")
	ItemTypes.ItemDefaultFuncs (o)
	o.Scale=1.0
	o.Orientation=(0.455262690783,-0.455772817135,0.536546051502,0.545092046261)

	o=Bladex.CreateEntity("charweapon3","BladeSword2Barbarian",40000,-1198.32521552,0.0, "Weapon")
	ItemTypes.ItemDefaultFuncs (o)
	o.Scale=1.2
	o.Orientation=(0.499999970198,0.500000059605,0.499999970198,-0.5)

	o=Bladex.CreateEntity("chararmor","ArmaduraBarbaroLigera",3.0632975424,-1118.41176074,-40000, Reference.ObjType("ArmaduraBarbaroLigera"))
	o.Scale=1.0
	o.Orientation=(0.711574673653,0.702310502529,0.00916196126491,0.0183697398752)

	o=Bladex.CreateEntity("charweapon4","LongSword",0,0,0,"Weapon")
	ItemTypes.ItemDefaultFuncs (o)
	Actions.TakeObject("Player1","charweapon4")
	# inv.LinkBack("charweapon4")





if (Bladex.GetEntity('Player1').Kind[0] == 'A'):

	char=Bladex.GetEntity("Player1")
	inv=char.GetInventory()

	o=Bladex.CreateEntity("charweapon3","Hachacuchilla",0.0,-1900.0,40000, "Weapon")
	o.Scale=1.0
	o.Orientation=(0.500000059605,-0.500000059605,0.499999940395,0.499999970198)
	ItemTypes.ItemDefaultFuncs (o)

	o=Bladex.CreateEntity("charweapon2","LanzaAncha",-40000,-1800.0,0.0, "Weapon")
	o.Scale=1.0
	o.Orientation=(0.500000059605,-0.500000059605,0.499999970198,0.499999940395)
	ItemTypes.ItemDefaultFuncs (o)

	o=Bladex.CreateEntity("charweapon1","SteelFeather",40000,-1400.0,0.0, "Weapon")
	o.Scale=1.0
	o.Orientation=(0.707106769085,-0.707106769085,0.0,0.0)
	ItemTypes.ItemDefaultFuncs (o)

	o=Bladex.CreateEntity("chararmor","ArmaduraAmazonaLigera",3.2093524697,-1006.8662989,-40000, Reference.ObjType("ArmaduraAmazonaLigera"))
	o.Scale=1.0
	o.Orientation=(0.709627091885,0.704157173634,-0.018258266151,0.0160831864923)

	o=Bladex.CreateEntity("charweapon4","Naginata",0,0,0,"Weapon")
	ItemTypes.ItemDefaultFuncs (o)
	Actions.TakeObject("Player1","charweapon4")
	# inv.LinkBack("charweapon4")
	


if (Bladex.GetEntity('Player1').Kind[0] == 'D'):

	char=Bladex.GetEntity("Player1")
	inv=char.GetInventory()

	o=Bladex.CreateEntity("charweapon3","Martillo",0.0,-800.0,40000, "Weapon")
	o.Scale=1.0
	o.Orientation=(0.430459350348,-0.560985505581,0.43045938015,-0.560985505581)
	ItemTypes.ItemDefaultFuncs (o)
	
	o=Bladex.CreateEntity("charweapon1","FireAxe",40000,-1000.0,0.0, "Weapon")
	o.Scale=1.0
	o.Orientation=(0.541870415211,0.575653016567,-0.449574500322,-0.415791749954)
	o.Lights = [(1.0, 0.03125, (255, 120, 0))]
	ItemTypes.ItemDefaultFuncs (o)

	o=Bladex.CreateEntity("charweapon2","Martillo3",-40000,-1000.0,0.0, "Weapon")
	o.Scale=1.0
	o.Orientation=(0.560985445976,0.560985565186,0.430459320545,0.430459439754)
	ItemTypes.ItemDefaultFuncs (o)

	o=Bladex.CreateEntity("chararmor","ArmaduraEnanoMedia",26.0701653453,-1120.84692057,-40000, Reference.ObjType("ArmaduraEnanoMedia"))
	o.Scale=1.0
	o.Orientation=(0.712009608746,0.701414346695,-0.0155441584066,0.0286119449884)

	o=Bladex.CreateEntity("charweapon4","Hacha4",0,0,0,"Weapon")
	ItemTypes.ItemDefaultFuncs (o)
	Actions.TakeObject("Player1","charweapon4")
	# inv.LinkBack("charweapon4")

	o=Bladex.CreateEntity("charshield","DalShield",0,0,0,"Weapon")
	ItemTypes.ItemDefaultFuncs (o)
	Actions.TakeObject("Player1","charshield")
	# inv.LinkBack("charshield")


if (Bladex.GetEntity('Player1').Kind[0] == 'K'):

	char=Bladex.GetEntity("Player1")
	inv=char.GetInventory()

	o=Bladex.CreateEntity("charweapon3","DoubleSword",0.0,-1200.0,40000, "Weapon")
	o.Scale=1.0
	o.Orientation=(0.707106769085,-0.707106769085,0.0,0.0)
	ItemTypes.ItemDefaultFuncs (o)

	o=Bladex.CreateEntity("charweapon1","QueenSword",40000,-1200.0,0.0, "Weapon")
	o.Scale=1.0
	o.Orientation=(0.500000059605,-0.500000059605,0.499999970198,0.499999940395)
	ItemTypes.ItemDefaultFuncs (o)

	o=Bladex.CreateEntity("charweapon2","Espada",-40000,-1200.0,0.0, "Weapon")
	o.Scale=1.0
	o.Orientation=(0.707106769085,0.0,-0.707106769085,0.0)
	ItemTypes.ItemDefaultFuncs (o)

	o=Bladex.CreateEntity("chararmor","ArmaduraCaballeroCompleta",0.0,-1800.0,-40000, Reference.ObjType("ArmaduraCaballeroCompleta"))
	o.Scale=1.0
	o.Orientation=(0.707106769085,0.707106769085,0.0,0.0)

	o=Bladex.CreateEntity("charweapon4","Espadaromana",0,0,0,"Weapon")
	ItemTypes.ItemDefaultFuncs (o)
	Actions.TakeObject("Player1","charweapon4")
	# inv.LinkBack("charweapon4")

	o=Bladex.CreateEntity("charshield","DalShield",0,0,0,"Weapon")
	ItemTypes.ItemDefaultFuncs (o)
	Actions.TakeObject("Player1","charshield")
	# inv.LinkBack("charshield")



o=Bladex.CreateEntity("drink1","PocimaTodo",0,0,0, Reference.ObjType("PocimaTodo"))
pocimac.CreatePotion(o.Name)
Actions.TakeObject("Player1","drink1")

o=Bladex.CreateEntity("drink2","Pocima200",0,0,0, Reference.ObjType("Pocima200"))
pocimac.CreatePotion(o.Name)
Actions.TakeObject("Player1","drink2")

o=Bladex.CreateEntity("drink3","Pocima200",0,0,0, Reference.ObjType("Pocima200"))
pocimac.CreatePotion(o.Name)
Actions.TakeObject("Player1","drink3")

o=Bladex.CreateEntity("drink4","Pocima100",0,0,0, Reference.ObjType("Pocima100"))
pocimac.CreatePotion(o.Name)
Actions.TakeObject("Player1","drink4")

o=Bladex.CreateEntity("drink5","Pocima100",0,0,0, Reference.ObjType("Pocima100"))
pocimac.CreatePotion(o.Name)
Actions.TakeObject("Player1","drink5")

o=Bladex.CreateEntity("drink6","Pocima100",0,0,0, Reference.ObjType("Pocima100"))
pocimac.CreatePotion(o.Name)
Actions.TakeObject("Player1","drink6")

o=Bladex.CreateEntity("drink7","Pocima100",0,0,0, Reference.ObjType("Pocima100"))
pocimac.CreatePotion(o.Name)
Actions.TakeObject("Player1","drink7")

o=Bladex.CreateEntity("drink8","PowerPotion",0,0,0, Reference.ObjType("PowerPotion"))
pocimac.CreatePowerPotion(o.Name)
Actions.TakeObject("Player1","drink8")

o=Bladex.CreateEntity("amulet","Amuletofantasma",0,0,0,"Physic")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject("Player1","amulet")

o=Bladex.CreateEntity("crown","Corona",0,0,0,"Physic")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject("Player1","crown")

o=Bladex.CreateEntity("bracelet","Brazalete",0,0,0,"Physic")
ItemTypes.ItemDefaultFuncs (o)
Actions.TakeObject("Player1","bracelet")



###############################################################################
# char effects
###############################################################################

GenFX.PersonMagicallyAppearing()


